<?php error_reporting(E_ALL);
class api_model extends CI_Model  {

	var $dbDataTable = "daily_data";
	var $dbStatsTable = "daily_stats";
	var $dbHrStatsTable = "hourly_stats";
	var $dbMonthlyGoalTable = "monthly_goal";

	function add_data($device_code, $watts=0, $units=0, $date="",$time="")
	{
		if (trim($device_code."") == ""){
			return;
		}
		$this->db->select("device_id, campus_id, building_id, floor_id, room_id");
		$this->db->where("device_code",$device_code);
		$rowDevice = $this->db->get("devices")->row();
		$device_id = $rowDevice->device_id;

		$this->db->select("user_id");
		$this->db->where("campus_id",$rowDevice->campus_id);
		$rowCampus = $this->db->get("campus")->row();
		$user_id = $rowCampus->user_id;

		$data["device_id"] = $device_id;
		if ($time == "")
			$time = date("H:i:s");
		if ($date == "")
			$date = date("Y-m-d");

		$hr = date("H", strtotime($date." ".$time));
		$data["log_date_time"] = $date." ".$time;
		$data["watts"] = $watts;
		$data["units"] = $units;
		$this->db->insert("daily_data", $data);

		$this->update_hourly_stats($device_id, $this->config->item('type_device'), $date, $hr, $watts, $units);
		$this->update_hourly_stats($rowDevice->room_id, $this->config->item('type_room'), $date, $hr, $watts, $units);
		$this->update_hourly_stats($rowDevice->floor_id, $this->config->item('type_floor'), $date, $hr, $watts, $units);
		$this->update_hourly_stats($rowDevice->building_id, $this->config->item('type_building'), $date, $hr, $watts, $units);
		$this->update_hourly_stats($rowDevice->campus_id, $this->config->item('type_campus'), $date, $hr, $watts, $units);
		
		$this->update_daily_stats($device_id, $this->config->item('type_device'), $date, $watts, $units);
		$this->update_daily_stats($rowDevice->room_id, $this->config->item('type_room'), $date, $watts, $units);
		$this->update_daily_stats($rowDevice->floor_id, $this->config->item('type_floor'), $date, $watts, $units);
		$this->update_daily_stats($rowDevice->building_id, $this->config->item('type_building'), $date, $watts, $units);
		$this->update_daily_stats($rowDevice->campus_id, $this->config->item('type_campus'), $date, $watts, $units);

		$this->load->model('settings/echarges_model');
		$this->echarges_model->set_user($user_id );
		$Kw = $watts / 1000;
		$cost = $this->echarges_model->calculatecharge($Kw);
		
		$this->update_monthly_goal($rowDevice->room_id, $this->config->item('type_room'), $user_id, $date, $Kw, $cost);
		$this->update_monthly_goal($rowDevice->floor_id, $this->config->item('type_floor'), $user_id, $date, $Kw, $cost);
		$this->update_monthly_goal($rowDevice->building_id, $this->config->item('type_building'), $user_id, $date, $Kw, $cost);
		$this->update_monthly_goal($rowDevice->campus_id, $this->config->item('type_campus'), $user_id, $date, $Kw, $cost);
	}
	

	function update_hourly_stats($id, $type, $stat_date, $hr, $watts, $units)
	{
		$this->db->where("id", $id);
		$this->db->where("type", $type);
		$this->db->where("stat_date", $stat_date);
		$this->db->where("hr", $hr);
		$hr_data = $this->db->count_all_results($this->dbHrStatsTable);
		if ($hr_data == 0)
		{
			$data = array();
			$data["id"] = $id;
			$data["type"] = $type;
			$data["stat_date"] = $stat_date;
			$data["hr"] = $hr;
			$data["watts"] = $watts;
			$data["units"] = $units;
			$this->db->insert($this->dbHrStatsTable, $data);
		}
		else
		{
			$this->db->set("watts","watts+".$watts,FALSE);
			$this->db->set("units","units+".$units,FALSE);
			$this->db->where("id", $id);
			$this->db->where("type", $type);
			$this->db->where("stat_date", $stat_date);
			$this->db->where("hr", $hr);
			$this->db->update($this->dbHrStatsTable);
		}
	}

	function update_daily_stats($id, $type, $stat_date, $watts, $units)
	{

		$sSql = "SELECT hs1.* FROM hourly_stats hs1 INNER JOIN (SELECT id, type, stat_date, min(watts) AS watts FROM hourly_stats GROUP BY id,type,stat_date) AS hs2 ON hs2.id=hs1.id AND hs2.type=hs1.type AND hs2.stat_date = hs1.stat_date AND hs2.watts = hs1.watts WHERE hs1.id=".$id." AND hs1.type='".$type."' AND hs1.stat_date='".$stat_date."'";

		$rsMin = $this->db->query($sSql)->row();

		$sSql = "SELECT hs1.* FROM hourly_stats hs1 INNER JOIN (SELECT id, type, stat_date, max(watts) AS watts FROM hourly_stats GROUP BY id,type,stat_date) AS hs2 ON hs2.id=hs1.id AND hs2.type=hs1.type AND hs2.stat_date = hs1.stat_date AND hs2.watts = hs1.watts WHERE hs1.id=".$id." AND hs1.type='".$type."' AND hs1.stat_date='".$stat_date."'";

		$rsMax = $this->db->query($sSql)->row();

		$sSql = "SELECT AVG(watts) as watts, AVG(units) as units, sum(watts) as total_watts, SUM(units) as total_units FROM hourly_stats WHERE id=".$id." AND type='".$type."' AND stat_date='".$stat_date."'";
		$rsAvg = $this->db->query($sSql)->row();

		$this->db->where("id", $id);
		$this->db->where("type", $type);
		$this->db->where("stat_date", $stat_date);
		$count = $this->db->count_all_results($this->dbStatsTable);
		$data["min_watt"] = $rsMin->watts;
		$data["max_watt"] = $rsMax->watts;
		$data["min_unit"] = $rsMin->units;
		$data["max_unit"] = $rsMax->units;
		$data["min_hr"] = $rsMin->hr;
		$data["max_hr"] = $rsMax->hr;
		$data["avg_watt"] = $rsAvg->watts;
		$data["avg_unit"] = $rsAvg->units;
		$data["total_watts"] = $rsAvg->total_watts;
		$data["total_units"] = $rsAvg->total_units;
		if ($count == 0)
		{
			$data["id"] = $id;
			$data["type"] = $type;
			$data["stat_date"] = $stat_date;
			$this->db->insert($this->dbStatsTable, $data);
		}
		else
		{
			$this->db->where("id", $id);
			$this->db->where("type", $type);
			$this->db->where("stat_date", $stat_date);
			$this->db->update($this->dbStatsTable, $data);
		}
	}

	function update_monthly_goal($id, $type, $user_id, $date, $watts, $cost)
	{
		$month = date("n",strtotime($date));
		$year = date("Y",strtotime($date));
		$day = date("j",strtotime($date));
		
		$currentmonthyear = $month.$year;
		$lastmonthyear = date("nY",mktime(0,0,0,($month-1),$day,$year));

		$this->db->where("id", $id);
		$this->db->where("type", $type);
		$this->db->where("month_year", $lastmonthyear);
		$hr_data = $this->db->get($this->dbMonthlyGoalTable)->row();
		$lastconsumption = 0;
		if ($hr_data)
		{
			$lastconsumption = $hr_data->actual_consumption;
		}
		
		$this->db->where("id", $id);
		$this->db->where("type", $type);
		$this->db->where("month_year", $currentmonthyear);
		$hr_data = $this->db->count_all_results($this->dbMonthlyGoalTable);
		if ($hr_data < 1)
		{
			$this->db->set("actual_consumption",$watts,FALSE);
			$this->db->set("actual_bill",$cost,FALSE);
			$this->db->set("id", $id);
			$this->db->set("type", $type);
			$this->db->set("month_year", $currentmonthyear);
			$this->db->set("user_id",$user_id);
			$this->db->insert($this->dbMonthlyGoalTable);
		}
		else
		{
			$this->db->set("actual_consumption","actual_consumption+".$watts,FALSE);
			$this->db->set("actual_bill","actual_bill+".$cost,FALSE);
			$this->db->where("id", $id);
			$this->db->where("type", $type);
			$this->db->where("month_year", $currentmonthyear);
			$this->db->update($this->dbMonthlyGoalTable);
		}
	}
}
?>