<?php
class counters_model extends CI_Model  {

	var $dbTable = "counters";
	var $dbInfoTable = "page_expiry_info";
	var $dbReachTable = "page_expiry_action_reach";
	var $User;

	function set_user($userId)
	{
		$this->User = $userId;
	}

	function get_counters_count()
	{
		$this->db->where("user_id",$this->User);
		return $this->db->count_all($this->dbTable);
	}
	function get_counters($per_page, $current_page)
	{
		$this->db->where("user_id",$this->User);
		$this->db->join($this->dbInfoTable,"counter_id=post_id");		
		$allcounters = $this->db->get($this->dbTable, $per_page, $current_page);
		return $allcounters;
	}

	function get_allcounters()
	{
		$this->db->where("user_id",$this->User);
		$this->db->join($this->dbInfoTable,"counter_id=post_id");
		$allcounters = $this->db->get($this->dbTable);
		return $allcounters;
	}
	function addCounter($counterData)
	{
		$counterBData["user_id"] = $this->User;
		$counterBData["title"] = $counterData["title"];
		unset($counterData["title"]);
		if ($this->db->insert($this->dbTable, $counterBData))
		{
			$counterId = $this->db->insert_id();
			$counterData["post_id"] = $counterId;
			$this->db->insert($this->dbInfoTable, $counterData);
			return $counterId;
		}
		else
		{
			return FALSE;
		}
	}

	function getCounter($counterId)
	{
		$this->db->where('user_id', $this->User);
		$this->db->where('counter_id', $counterId);
		$this->db->join($this->dbInfoTable,"counter_id=post_id");
		$this->db->join($this->dbReachTable,"counter_id=".$this->dbReachTable.".P_Id","left");
		return $this->db->get($this->dbTable);
	}
	
	function updateCounter($counterId, $counterData)
	{
		$this->db->where('post_id', $counterId);
		$this->db->delete($this->dbInfoTable);

		$counterBData["title"] = $counterData["title"];
		$this->db->where('user_id', $this->User);
		$this->db->where('counter_id', $counterId);
		unset($counterData["title"]);
		if ($this->db->update($this->dbTable, $counterBData))
		{
			$counterData["post_id"] = $counterId;
			$this->db->insert($this->dbInfoTable, $counterData);
			return $counterId;
		}
		else
		{
			return FALSE;
		}
	}
	
	function deleteCounter($counterId)
	{
		$this->db->where('counter_id', $counterId);
		$this->db->where('user_id', $this->User);
		if ($this->db->delete($this->dbTable))
		{
			$this->db->where('post_id', $counterId);
			$this->db->delete($this->dbInfoTable);
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	function checkDuplicate($user_name, $id=0)
	{
		$this->db->where('user_name', $user_name);
		if ($id > 0)
			$this->db->where('user_id !=', $id);
		$result = $this->db->get($this->dbTable);
        // Is there a row with this email?
        if ($result->num_rows > 0)
			return 1;
		else
			return 0;
	}

	function get_user_roles()
	{
		return $this->db->get('user_roles');
	}

	function get_counter_action_reach_data($counterId)
	{
		$this->db->where('P_Id', $counterId);
		$result = $this->db->get($this->dbReachTable);
		return $result;
	}

	function addCounterReaches($ReachesData)
	{
		if ($this->db->insert($this->dbReachTable, $ReachesData))
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	
	function updateCounterReaches($counterId, $ReachesData)
	{
		$this->db->where('P_Id', $counterId);
		$this->db->update($this->dbReachTable, $ReachesData);
	}

	function delCounterReaches($CounterId)
	{
		$this->db->where('P_Id', $CounterId);
		$this->db->delete($this->dbReachTable);
	}
}
?>