<?php

class Users extends MY_AdminController {

	function Users()
	{
		parent::__construct();
		$this->load->helper('string');
		$this->load->model('users_model');
		$this->users_model->set_parent(2);
	}

	// --------------------------------------------------------------------

	function index()
	{
		/*$data = $this->defaultPageContents($this->uri->segment(3));
	
		$this->template->build('index', $data);*/
		$this->edit($this->session->userdata("user_id"));
	}

	function edit($id)
	{
		$data = $this->defaultPageContents();
		$data["act"] = "Edit";
		$user = $this->users_model->getuser($id);
		$userDetails = $user->row();
		$data["email"] = $userDetails->email;
		$data["name"] = $userDetails->contact_name;
		$data["company"] = $userDetails->company_name;
		$data["phone"] = $userDetails->contact_phone;
		//$data["pwd"] = $userDetails->user_pwd;
		$data["user_name"] = $userDetails->user_name;
		$data["pid"] = $userDetails->parent_user;
		if ($userDetails->status == 1)
			$data["status"] = "checked";
		else
			$data["status"] = "";
		$data["id"] = $id;
		$data["form_action"] = "users/update";
		$this->template->build('index', $data);
	}

	function insert()
	{
		if (!$this->users_model->checkDuplicate($this->input->post('ph')))
		{
			$user_data = array(
							'email' => $this->input->post('e'),
							'contact_name' => $this->input->post('n'),
							'company_name' => $this->input->post('c'),
							'user_name' => $this->input->post('u'),
							'contact_phone' => $this->input->post('ph'),
							'user_pwd' => $this->input->post('p'),
							'status'=>  $this->input->post('s'),
							'parent_user'=>  1,
						);

			$user_id = $this->users_model->adduser($user_data);
			$data = $this->defaultPageContents();
			$data["msg"]= "user added successfully.";
			$data["msgDisplay"]= "block";
			$data["msgType"]= "success";
		}
		else
		{
			$data = $this->defaultPageContents();
			$data["email"] = $this->input->post('e');
			$data["pid"] = $this->input->post('pid');
			$data["name"] = $this->input->post('n');
			$data["pwd"] = $this->input->post('p');
			$data["company"] = $this->input->post('c');
			$data["user_name"] = $this->input->post('u');
			$data["phone"] = $this->input->post('ph');
			if ($this->input->post('s') == 1)
				$data["status"] = "checked";
			else
				$data["status"] = "";
			$data["msg"]= "user already exists.";
			$data["msgDisplay"]= "block";
			$data["msgType"]= "error";
		}
		$this->template->build('index', $data);
	}

	function update()
	{
		if (!$this->users_model->checkDuplicate($this->input->post('ph'), $this->input->post('i')))
		{
			$user_data = array(
							'email' => $this->input->post('e'),
							'contact_name' => $this->input->post('n'),
							'company_name' => $this->input->post('c'),
							'user_name' => $this->input->post('u'),
							'contact_phone' => $this->input->post('ph'),
							'status'=>  $this->input->post('s'),
							'parent_user'=>  1,
						);
			if (trim($this->input->post('p')) != "")
				$user_data['user_pwd'] = $this->input->post('p');
			$user_id = $this->users_model->updateuser( $this->input->post('i'), $user_data);
			$data = $this->defaultPageContents();
			$data["msg"]= "user added successfully.";
			$data["msgDisplay"]= "block";
			$data["msgType"]= "success";
		}
		else
		{
			$data = $this->defaultPageContents();
			$data["email"] = $this->input->post('e');
			$data["company"] = $this->input->post('c');
			$data["user_name"] = $this->input->post('u');
			$data["phone"] = $this->input->post('ph');
			$data["pid"] = $this->input->post('pid');
			$data["name"] = $this->input->post('n');
			$data["id"] = $this->input->post('i');
			$data["pwd"] = $this->input->post('p');
			if ($this->input->post('s') == 1)
				$data["status"] = "checked";
			else
				$data["status"] = "";
			$data["msg"]= "user already exists.";
			$data["msgDisplay"]= "block";
			$data["msgType"]= "error";
			$data["act"] = "Edit";
			$data["form_action"] = "users/update";
		}
		$this->template->build('index', $data);
	}
	function delete($userId)
	{
		$user_id = $this->users_model->deleteuser($userId);
		$data = $this->defaultPageContents();
		$data["msg"]= "user deleted successfully.";
		$data["msgDisplay"]= "block";
		$data["msgType"]= "success";
		$this->template->build('index', $data);
	}


	function defaultPageContents($currentPage = 0)
	{
		$config = $this->config->item("pagination");
		$data["pid"] = "2";
		$data["email"] = "";
		$data["name"] = "";
		$data["company"] = "";
		$data["user_name"] = "";
		$data["pwd"] = "";
		$data["status"] = "";
		$data["phone"] = "";
		$data["msg"]= "";
		$data["msgDisplay"]= "none";
		$data["msgType"]= "success";
		
		$data["id"] = 0;
		
		$data['page_title'] = 'Users';
		
		$data["act"] = "Add";
		$data["form_action"] = "users/insert";
		
		$data['users'] = $this->users_model->get_users($config['per_page'], $currentPage)->result();
		
		$config['base_url'] = site_url('users/index/');
		$config['total_rows'] = $this->users_model->get_users_count();
		$this->pagination->initialize($config); 
		$data['pagination'] = $this->pagination->create_links();
		
		return $data;
	}
}
 
?>