<?php
class users_model extends CI_Model  {

	var $dbTable = "users";
	var $parentUser;

	function set_parent($userId)
	{
		$this->parentUser = $userId;
		$this->load->library('encrypt');
	}

	function get_users_count()
	{
		$this->db->where("parent_user",$this->parentUser);
		return $this->db->count_all($this->dbTable);
	}
	function get_users($per_page, $current_page)
	{
		$this->db->where("parent_user",$this->parentUser);
		$this->db->or_where("user_id",$this->parentUser);
		$allusers = $this->db->get($this->dbTable, $per_page, $current_page);
		return $allusers;
	}

	function get_allusers()
	{
		$this->db->where("parent_user",$this->parentUser);
		$this->db->or_where("user_id",$this->parentUser);
		$allusers = $this->db->get($this->dbTable);
		return $allusers;
	}
	function adduser($userData)
	{
		$userData['user_pwd'] = $this->encrypt->encode($userData['user_pwd']);
		if ($this->db->insert($this->dbTable, $userData))
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}

	function getuser($userId)
	{
		$this->db->where('user_id', $userId);
		return $this->db->get($this->dbTable);
	}
	
	function get_user_by_email($email)
	{
		$this->db->where('email', $email);
		return $this->db->get($this->dbTable);
	}
	function get_user_by_username($username)
	{
		$this->db->where('user_name', $username);
		return $this->db->get($this->dbTable);
	}
	function updateuser($userId, $userData)
	{
		$userData['user_pwd'] = $this->encrypt->encode($userData['user_pwd']);
		$this->db->where('user_id', $userId);
		if ($this->db->update($this->dbTable, $userData))
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	
	function deleteuser($userId)
	{
		$this->db->where('user_id', $userId);
		if ($this->db->delete($this->dbTable))
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	function checkDuplicate($user_name, $id=0)
	{
		$this->db->where('user_name', $user_name);
		if ($id > 0)
			$this->db->where('user_id !=', $id);
		$result = $this->db->get($this->dbTable);
        // Is there a row with this email?
        if ($result->num_rows > 0)
			return 1;
		else
			return 0;
	}

	function get_user_roles()
	{
		return $this->db->get('user_roles');
	}
}
?>